/* 
   Passifist
   Copyright (C) Patrik Karlsson <patrik@cqure.net> 2003
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "plugin.h"

struct conn_info {
  char user[255];
  char pw[255];
  char db[255];
  char host[255];
  char name[255];
  char session[255];
};

struct store_info {
  void *(*db_connect)(char *);
  void (*db_disconnect)(void *);
  int (*db_storehost)(void *, char *, char *, char *, char *, char *);
  int (*db_storeproperty)(void *, char *, char *, char *);
  void *(*db_getname)(void);
  void *(*db_getdescription)(void);
  void *handle;
};

int store_storehost(const struct host *);
int store_storeproperty(const struct property *, char *);
int store_connect(char *);
void store_disconnect();
char *store_getplugdesc( char * );
int store_createsession( char * );
