/* 
   Passifist
   Copyright (C) Patrik Karlsson <patrik@cqure.net> 2003
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "plugin.h"
#include "util.h"

struct host *plug_storehost( struct host *host,
			     const char mac[20],
			     const char addr[50],
			     const char name[255],
			     const char type[20]) {

  struct host *newhost;

  newhost = ( struct host * ) malloc ( sizeof( struct host ) );

  if ( !newhost ) {
    return NULL;
  }

  strncpy( newhost->mac, mac, sizeof( newhost->mac ) - 1 );
  strncpy( newhost->addr, addr, sizeof( newhost->addr ) - 1 );
  strncpy( newhost->name, name, sizeof( newhost->name ) - 1 );
  strncpy( newhost->type, type, sizeof( newhost->type ) - 1 );

  newhost->prop = NULL;
  newhost->next = host;
  host = newhost;

  return host;

}

void plug_freehost( struct host *host ) {

  struct host *curr, *rmv;

  curr = host;

  while ( curr ) {
    rmv = curr;
    curr = curr->next;
    plug_freeproperty( rmv->prop );
    free(rmv);
  }

  host = NULL;

}


int plug_storeproperty( struct host *pHost,
			 const char prop[256],
			 const char val[8192] ) {
  
  struct property *newprop;

  newprop = ( struct property * ) malloc( sizeof( struct property ) );
  
  if ( !newprop )
    return -1;

  memset( newprop->val, 0, sizeof( newprop->val ) );
  strncpy( newprop->val, val, sizeof( newprop->val ) - 1 );

  memset( newprop->prop, 0, sizeof( newprop->prop ) );
  strncpy( newprop->prop, prop, sizeof( newprop->prop ) - 1 );

  newprop->next = pHost->prop;
  pHost->prop = newprop;

  return 0;

}

void plug_freeproperty( struct property *prop ) {

  struct property *curr, *rmv;

  curr = prop;

  while ( curr ) {
    rmv = curr;
    curr = curr->next;
    free(rmv);
  }

  // prop = NULL;

}

