/* 
   Passifist
   Copyright (C) Patrik Karlsson <patrik@cqure.net> 2003
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define ETHER_ADDR_LEN 6
struct	ether_header {
	u_int8_t  ether_dhost[ETHER_ADDR_LEN];
	u_int8_t  ether_shost[ETHER_ADDR_LEN];
	u_int16_t ether_type;
};

const u_int16_t SRV_TYPE_FILESERVER = 0x0004;
const u_int16_t SRV_TYPE_UNIVELUNIXWARE = 0x03E1;
const u_int16_t SRV_TYPE_HPJETDIRECT = 0x030c;
const u_int16_t SRV_TYPE_LANTERN = 0x023A;
const u_int16_t SRV_TYPE_NWMANAGEMENTAGENT = 0x0004;
const u_int16_t SRV_TYPE_MSGWSERVICESNW = 0x0640;
const u_int16_t SRV_TYPE_NDS4 = 0x0278;
const u_int16_t SRV_TYPE_BTRIEVENLM5 = 0x004B;
const u_int16_t SRV_TYPE_SMSTESTDEVELOP = 0x023f;
const u_int16_t SRV_TYPE_TESNWFORVMS = 0x007A;
const u_int16_t SRV_TYPE_LANPROTECTBINDERY = 0x0102;
const u_int16_t SRV_TYPE_NW386ORRSPXRCONSOLE = 0x0107;
const u_int16_t SRV_TYPE_ARCSERVE501 = 0x044c;
const u_int16_t SRV_TYPE_TIMESYNCSERVER = 0x026B;
const u_int16_t SRV_TYPE_ADVPRINTSVC = 0x0047;
const u_int16_t SRV_TYPE_NOVELLTIRPC = 0x000f;
const u_int16_t SRV_TYPE_XEROX = 0x07c6;
const u_int16_t SRV_TYPE_KYOCERA = 0x0414;
const u_int16_t SRV_TYPE_MSIIS = 0x064E;
const u_int16_t SRV_TYPE_CANONGP55 = 0x0457;
const u_int16_t SRV_TYPE_LEGATO = 0x01F5;
const u_int16_t SRV_TYPE_LOTUSNOTES = 0x039B;
const u_int16_t SRV_TYPE_NW386 = 0x8104;
const u_int16_t SRV_TYPE_NMSIPDISCORLANTERNTRAP = 0x0238;

struct ipx_header {
  u_int16_t chksum;
  u_int16_t length;
  u_int8_t tcontrol;
  u_int8_t type;
  u_int32_t dstnet;
  u_int8_t dstnode[6];
  u_int16_t dstsocket;
  u_int32_t srcnet;
  u_int8_t srcnode[6];
  u_int16_t srcsocket;
} __attribute__((packed));

struct ipx_sap {
  u_int16_t srvtype;
  u_int8_t servername[48];
  u_int8_t network[4];
  u_int8_t node[6];
  u_int16_t socket;
  u_int16_t intermediatenets;
} __attribute__((packed));



struct nwhost {
  u_char server[48];
  u_int8_t ether[6];
  u_int16_t srvtype;
  u_int8_t network[4];
  u_int8_t node[6];
  u_int8_t md5[16];
  void *next;
};

static struct nwhost *nwhosts = NULL;
static u_int16_t nPacketCount = 0;

