/* 
   Passifist
   Copyright (C) Patrik Karlsson <patrik@cqure.net> 2003
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "openssl/md5.h"

int md5comp( const char md5_1[16], const char md5_2[16] ) {

  int i;

  for ( i=0; i<16; i++ ) {
    if ( md5_1[i] != md5_2[i] )
      return 1;
  }

  return 0;

}

unsigned char *createMD5( const char *pData, const int nLen ) {

  MD5_CTX ctx;
  unsigned char *md5dig = ( unsigned char * ) malloc ( 17 );

  if ( !md5dig )
    return NULL;

  MD5_Init( &ctx );
  MD5_Update( &ctx, pData, nLen );
  MD5_Final( md5dig, &ctx );
  md5dig[16] = '\0';
  return md5dig;

}

void md5ToAscii( char *md5ascii, const unsigned char *md5 ) {

  int i;
  unsigned char hex[3];
  char ascii[40];

  memset( ascii, 0, sizeof( ascii ) );

  for ( i=0; i<16; i++ ) {
    memset( hex, 0, 3 );
    sprintf( (char *)&hex, "%.2X", md5[i] );
    strncat( ascii, hex, 2 );
  }

  memcpy( md5ascii, ascii, 32 );

} 

void mactostr(char *pStrMac, const unsigned char *pMac) {

  int i;
  unsigned char hex[3];

  /* ether len as str is 18 */
  memset( pStrMac, 0, 18);

  for ( i=0; i<6; i++ ) {
    memset( hex, 0, sizeof( hex ) );
    sprintf( (char *)&hex, "%.2X", pMac[i]);
    strncat( pStrMac, hex, 2 );

    if ( i<5 )
      strcat( pStrMac, ":");

  }
    

}
