/* 
   Passifist
   Copyright (C) Patrik Karlsson <patrik@cqure.net> 2003
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "util.h"

char prefix[20];
char filename[255];

char *db_parameters() {
  return "filename=<filename>";
}


int db_storehost( FILE *pConn, char *mac, char *addr, char *name, 
		   char *type, char *props ) {

  int nLen;

  bzero( filename, sizeof( filename ) );
  strncpy( filename, prefix, sizeof( prefix ) );

  nLen = strlen( filename ) + 1 + strlen( type );

  if ( nLen > sizeof( filename ) )
    return -1;

  strcat( filename, "-" );
  strncat( filename, type, strlen(type) );
  pConn = fopen( filename, "a" );

  fprintf(pConn, "--\n");
  fprintf(pConn, "%s,%s,%s,%s\n", mac, addr, name, type );

  fclose( pConn );
  
  return 0;
}

int db_storeproperty(FILE *pConn, const char *name, 
		     const char *val, const char *chksum) {

  pConn = fopen( filename, "a" );
  fprintf(pConn, "%s=>%s\n", name, val );
  fclose( pConn );

  return 0;
}

FILE *db_connect( const char *pConnURL ) {

  char *pFilename = getparamvalue( pConnURL, "filename" );

  if ( !pFilename ) {
    fprintf( stderr, "Connect failed make sure all parameters are supplied\n");
    fprintf( stderr, "%s\n", db_parameters() );
    freeparamvalue( pFilename );
    return NULL;
  }

  bzero( prefix, sizeof( prefix ) );
  strncpy( prefix, pFilename, sizeof( prefix ) - 1 );
  freeparamvalue( pFilename );

  return stdout;
}

void db_disconnect(FILE *pConn) {

}

char *db_getname() {
  return "TXTADV";
}

char *db_getdescription() {
  return "Storage plugin for separate output files";
}
